# Workflow
In our team, we use **Agile Scrum workflow**. This means that we have a strict structure which controls development, task completion and release frequency. One of fundamental basics of Agile are **sprints**. Sprints are small individual cycles of production process. Sprint is usually 2 weeks long. Two sprints are called **epic** (one month of working). **Stories**, also called “user stories,” are short requirements or requests written from the perspective of an end user. Supervisors divide one user story to tasks and assign them to lower posistions. **Task** is a task. Usually it should not take more than 2 days or less than 2 hours.

At the end of each sprint, we have **a general meeting** with all teams to discuss the tasks and problems that have arisen. We also hold **small meetings** within every team to explain user stories or programming concepts. Each day at the end, each member of each team must **report** on the progress of their tasks and the problems for the day to their higher positions. It can be in writing or orally, depending on the supervisor.

*   In case of anything, **notify your supervisor** because he has a plan which should be executed. Any problem can be solved, and your colleagues can help you, so **don&#39;t be shy**.
*   If you have an idea how to improve the code, **don&#39;t do it yourself**, tell your supervisor about it first.
*   We have a very strict rule: **DON&#39;T CHANGE ANYTHING WITHOUT NOTIFYING SOMEONE**.

## **Kanban board**

To implement the workflow we use the [**kanban board**](https://board.techpal.ru/). Here we track our tasks and stories for each sprint. Each task has an estimated time to complete it. There are 4 stages for each task or story:

*   **To Do.** Here are tasks which should be finished to the end of the sprint. Here, if you are supervisor, you can also find user stories to divide into tasks.
*   **In Progress.** Here are tasks which you that you are currently doing. Don&#39;t forget to move the task back to To Do.
*   **Waiting for approval.** Here are tasks that you finished. Your supervisor should check to see if your feature is working in a proper way, and if not, they will move it back to To Do.
*   **Done**. Here are tasks which are done. **Never ever** move your tasks here, only the team lead can do that after they has checked if the feature is working properly.
